/*
   Projekt z Podstaw Informatyki 2003/2004
   Napisac algorytm i funkcje zwracajaca macierz kolumnowa powstala z macierzy
   wejsciowej poprzez wymnorzenie elmentow w wierszach.
*/

#include <stdio.h>
#include <conio.h>

void mnozenie_elementow (int w, int k); //deklaracja funkcji

/* !!!!!!!!!!!!!!!!!!!!! PROGRAM GLOWNY !!!!!!!!!!!!!!!!!!!!!!!!!*/
void main (void)
{
int m,n; //zmienne typu calkowitego okreslajace ilosc kolumn i wierszy macierzy
int c; //zmienna do ktorej bede zapisywal przycisk z klawiatury


textmode(3); //przejscie do trybu tekstowego
clrscr(); //czyszcze ekran przed wyswietleniem
gotoxy(25,10); //ustawiam kursor w odpowiednim mejscu ekranu


/* Wyswietlam informacje o projekcie */
printf("PROJEKT Z PODSTAW INFORMATYKI\n\n\n\r");
printf(" Zadanie 29:\n Napisac algorytm i funkcje zwracajaca mecierz kolumnowa powstala\n z macierzy wejsciowej poprzez wymnozenie elementow w wierszach.");
printf("\n\n\n\r Zalozenia:\n Funkcja nie wykorzystuje zadnych zmiennych globalnych,\n umozliwia wykonanie operacji na macierzach o roznych wymiarach");
printf("\n (ustalonych na etapie wywolania funkcji), nie modyfikuje macierzy wejsciowej.\n Program glowny wyswietla dane wejscowe oraz wynikowe w postaci macierzy.\n");
printf("\n\n\n\n Projekt wykonal: ZGNILEC DARIUSZ  &  DUDEK LUKASZ");
printf("\n\n\n\n\t\t(Nacisnij dowolny klawisz)");
_setcursortype(_NOCURSOR);
/* Koniec wyswietlania informacji */

getch(); //czekam na nacisniecie dowolnego klawisza

   clrscr(); //czyszcze ponownie ekran
   _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny

   // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy
   printf("\nPODAJ ROZMIAR MACIERZY\nLiczba wierszy macierzy: ");
   scanf("%d",&n);
   printf("Liczba kolumn macierzy:");
   scanf("%d",&m);
   // Koniec wyswietlania informacji


do{
   /* Jezeli chce ponownie wprowadzic dane to ... */
   if (c=='w' || c=='W')
      {
      clrscr(); //czyszcze ponownie ekran
      _setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny

      // Wyswietlam na ekranie komunikaty o podanie ilosci wierszy i kolumn macierzy A i B
      printf("\nPODAJ ROZMIAR MACIERZY\nLiczba wierszy macierzy:");
      scanf("%d",&n);

      printf("Liczba kolumn macierzy:");
      scanf("%d",&m);
      // Koniec wyswietlania informacji
      }

   if (c=='k' || c=='K') //jezeli nacsniesz 'k' zostanie wywolana funkcja mnazaca elmenty
      mnozenie_elementow(n,m); //z dwoma parametrami 'm' i 'n' - iloscwierszy i kolumn

/* Tu wypisuje na ekranie informacje o rozmiarze macierzy i o tym, czy mam kontynuowac wprowadzanie danych czy nie*/
      clrscr(); //czyszcze ekran
      printf("\tPodana macierz ma wymiary %dx%d\n\n",n,m); //wyswietlam na ekranie
      textcolor(WHITE); //zmieniam kolor czcionki na bialy aby ...
      cprintf("          W"); //podswietlic literke "W"
      printf("prowadz ponownie"); //dokanczam napis
      cprintf("          K"); //jak wyrzej z literka "K"
      printf("ontynuuj"); //i dokanczam napis
      cprintf("          Z"); //jak wyrzej z literka "Z"
      printf("akoncz"); //i dokanczam napis
      _setcursortype(_NOCURSOR); //ukrywam migajacy kursor
      lowvideo(); //przechodze w tryb szarych liter
      c = getch(); //czekam na wprowadzenie znaku z klawiatury
} while(c!='z'|| c!='Z'); //koncze powtarzanie petli jezeli klawisz nacisniety to 'z'

}
/* !!!!!!!!!!!!!!!!!! KONIEC PROGRAMU GLOWNEGO !!!!!!!!!!!!!!!!!! */





/* !!!!!!!!!! FUNKCJA SUMUJACA DWIE MACIERZE !!!!!!!!!! */
void mnozenie_elementow (int w, int k)
{
float tab_A[100][100], tab_B[100][1]; //deklaracja tablic,
				      //pierwsza moze miec rozmiar mniejszy lub rowny
				      //100, druga moze miec max. 100 wierszy, ale
				      //ma tylko 1 kolumne.
				      //Wynika to z tego, ze po wymnozeniu do tej macierzy bede wprowadzal dane
				      //a beda one w postaci kolumny powstalej z wymnozenia odpowiednich
				      //elementow w wierszach macierzy
float iloczyn; //zmienna do ktorej bede zapisywal iloczyn
int i,j; //zmienne do indeksowania macierzy przy wprowadzaniu danych
int c; //zmienna do ktorej bede zapisywal znak z klawiatury

clrscr(); //czyszcze ponownie ekran
_setcursortype(_NORMALCURSOR); //ustawiam kursor na normalny


/* WPROWADZAM DANE DO MACIERZY "A" */
//wczytywanie elementow macierzy - wczytuje elementy wierszami
for(i=0;i<w;i++) //od 0-wego elementu do w-ilosci wierszy
   {
   printf("\nWprowadz elementy %d-go wiersza macierzy 'A'\n",i+1); //komunikat
   for(j=0;j<k;j++) //tu pobieam elementy j-tej kolumny
      scanf("%f",&tab_A[i][j]); //i zapisuje do komurki o indeksie A[i][j]
   }


/* FUNKCJA LICZACA ILOCZYN */
for(i=0;i<w;i++)//podobnie jak przy wprowadzaniu
		//przy mnozeniu tez zaczynam od 0-wego i koncze na w-ilosc wierszy
   {
   iloczyn = 1; //na poczatek iloczyn wynosi 1, poniewz jakakolwiek liczba razy 1 nie zmieni sie
   for(j=0;j<k;j++) //po wszystkich kolumnach
      iloczyn*=tab_A[i][j]; //iloczyn jest rowny iloczyn razy liczba A[i][j]
   tab_B[i][1] = iloczyn; //jezeli skoncza sie elementy w wierszu zapisuje wynik do macierzy kolumnowej B
  }

       clrscr(); //czyszcze ekran
       textcolor(WHITE); //zmieniam kolor
       printf("      Macierz "); //wyswietlam napis
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       _setcursortype(_NOCURSOR); //ukrywam kursor
       lowvideo(); //szare literki

do{
  c= getch(); //czekam na wprowadzeni znaku z klawiatury
  if (c=='a' || c=='A') //jezeli znak wprowadzony to 'a' wtedy...
     {
       clrscr(); //czyszcze ekran
       textcolor(WHITE); //zmieniam kolor czcionki
       printf("      Macierz "); //wyswietlam napisy na ekranie
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'A'");
       _setcursortype(_NOCURSOR); //ukrywam kursor
       lowvideo(); //przechodze w tryb szaryc liter
       for(i=0;i<w;i++) //wyswietlam macierz wiersz po wierszu
	  {
	  printf("\n");
	  for(j=0;j<k;j++)
	     printf("%8.2f",tab_A[i][j]);
	  }
     }
   else
  if (c == 'b' || c=='B') //jezeli klawisz 'b' dzieje sie to samow jak wyrzej
      {
       clrscr();
       textcolor(WHITE);
       printf("      Macierz ");
       cprintf("A");
       printf("      Macierz ");
       cprintf("B");
       cprintf("     W");
       printf("prowadz ponownie\n\n\n\n");
       printf("\n\nMacierz 'B'");
       _setcursortype(_NOCURSOR);
       lowvideo();
     for(i=0;i<w;i++)
	{
	printf("\n");
	printf("%10.2f",tab_B[i][1]);
	}
      }
  }while(c!='w' || c!='W'); //koncze kiedy przycisk = 'w'
}
/* !!!!!!!!!! KONIEC !!!!!!!!!! */